/* 
 * KismetManager.c, by Anmol Madan  Copyright (C) 2004, MIT Media Lab. 
 * Distributed under GNU/GPL agreement
 *
 * Manager app responsible for starting and stopping Kismet and 
 * bluetooth scanner. Relies on a clean installation of Kismet and 
 * bluetooth driver
 */


#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <signal.h>

unsigned short  state;
#define FALSE 0
#define TRUE 1

void sighandler(int sig)
{

  // cleanup and exit
    
  printf("Ctrl C caught! Exiting ... ");
  fflush(stdout);
	
  if (state==TRUE) {
    system("killall kismet_server");
    sleep(2);
    system("usbctl off 1");
    sleep(2);
    //  system("rm /mnt/card/borglab/wifidata/Kismet.network");
    // sleep(2);
  }

  exit(EXIT_SUCCESS);
  
}

int main(int argc, char *argv[]) 
{


  int on=15;
  int off=90, i=0, bon=12;
  
  state=FALSE;

  signal(SIGINT,sighandler);

  system("/etc/rc.d/init.d/bluetooth stop");

  
    if (argc>1)
	on = atoi(argv[1]);
    
    if (argc>2)
      off = atoi(argv[2]);
    
    if (argc>3)
      bon = atoi(argv[3]);



  while(i>=0) {
 

   // start Kismet
    
    system("rm /mnt/card/borglab/wifidata/Kismet.network");
    sleep(2);

    state=TRUE;
    system("usbctl on 1");
    sleep(2);
    system("wlanctl-ng wlan0 lnxreq_ifstate ifstate=enable");
    sleep(2);
    system("ifconfig wlan0 1.1.1.1 up");
    sleep(2);
    system("kismet_server &");
    sleep (on);
    i++;

    // kill kismet
    system("killall kismet_server");   
    sleep(2);
    system("usbctl off 1");
    sleep(2);
    system(" date >> /mnt/card/borglab/wifidata/locmap");
    sleep(2);	
    system("grep \"Network\" /mnt/card/borglab/wifidata/Kismet.network >> /mnt/card/borglab/wifidata/locmap");    
    sleep(2);
    system("rm /mnt/card/borglab/wifidata/Kismet.network");
    sleep(2);
    system("/etc/rc.d/init.d/bluetooth start");
    sleep(2);
    system(" hcitool scan | grep \":\" >> /mnt/card/borglab/wifidata/locmap");
    sleep(bon);
    system("/etc/rc.d/init.d/bluetooth stop");
    sleep(2);
    printf("Iteration %d completed. Use Ctrl C to kill this app.",i); 
    fflush(stdout);
    state=FALSE;
    sleep(off);
  }  

  return 0;
}

