/*************************************************
 * File: dstring.c
 * Author: Jonathan Gips
 * Birth Date: 6/29/01
 *
 * Project: Enchantment IPC
 * 
 * Based on Enchantment IPC Whitepaper
 *   by Edward Keyes.
 *
 * Copyright (C) 2002 MIT Media Lab,
 *               2004 AWare Technologies, Inc.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 *
 *************************************************/

#ifndef ENCHANTMENT_DSTRING_H
#define ENCHANTMENT_DSTRING_H

/* Returns an interned string from the given string, in new memory. */
const char *InstanceString(const char *string);

/* 
 * Returns an interned string from the first len characters of the
 * given string, in new memory. 
 */
const char *InstanceStringN(const char *string, int len);

/* Returns an interned string of the given number. */
const char *InstanceNumber(int i);

#endif
