/*************************************************
 * File: symbols.c
 * Birth Date: 12/3/2003
 *
 * Project: Enchantment IPC
 * 
 * Based on Enchantment IPC Whitepaper
 *   by Edward Keyes.
 * 
 * Copyright (C) 2002 MIT Media Lab
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *************************************************/

#include <stdlib.h>
#include "symbols.h"
#include "whiteboard-protocol.h"
#include <enchantment/dstring.h>

#define KV_MERGE                    "kom" 
#define KV_REPLACE                  "kor"
#define KV_ADDONLY                  "koa"

const char *c_get = NULL, *c_getlock = NULL;
const char *c_lock = NULL;
const char *c_publish = NULL, *c_unpublish = NULL, *c_subscribe = NULL;
const char *c_unsubscribe = NULL, *c_getmeta = NULL, *c_setmeta = NULL;

const char *kv_merge = NULL, *kv_addonly = NULL;
const char *kv_replace = NULL;

void InitSymbols()
{
  if (!c_get)
    {
      // String constant initialization
      c_get = InstanceString(C_GET);
      c_getmeta = InstanceString(C_GET_META);
      c_setmeta = InstanceString(C_SET_META);
      c_getlock = InstanceString(C_GETLOCK);
      c_lock = InstanceString(C_LOCK);
      c_publish = InstanceString(C_PUBLISH);
      c_subscribe = InstanceString(C_SUBSCRIBE);
      c_unsubscribe = InstanceString(C_UNSUBSCRIBE);
      kv_addonly = InstanceString(KV_ADDONLY);
      kv_replace = InstanceString(KV_REPLACE);
      kv_merge = InstanceString(KV_MERGE);
    }
}
