/*************************************************
 * File: test-utils.h
 * Birth Date: Sep 02, 2004
 *
 * Project: Enchantment IPC
 * 
 * Based on Enchantment IPC Whitepaper
 *   by Edward Keyes.
 *
 * Copyright (C) 2004 Aware Technologies, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 *************************************************/

#ifndef TEST_UTILS_H
#define TEST_UTILS_H

#include <stdarg.h>

extern int subclient;
extern int issubclient;
extern int failures;

typedef struct
{
  char *name;
  void (*main)();
  void (*sub)();
} test;

// Provided by test to test-utils
void done();
extern test tests[];

// Provided by test-utils
void fail(char *format, ...);
void vfail(char *format, va_list args);
void check(int cond, char *format, ...);
void vcheck(int cond, char *format, va_list args);
void require(int cond, char *format, ...);
void vrequire(int cond, char *format, va_list args);
void info(char *format, ...);
void turn(char *format, ...);

void splitSubclient(char *cases);

#endif
