/*************************************************
 * File: time-axis.h
 * Birth Date: Jan 11, 2004
 *
 * Project: Enchantment IPC
 * 
 * Based on Enchantment IPC Whitepaper
 *   by Edward Keyes.
 *
 * Copyright (C) 2004 MIT Media Lab
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 *************************************************/

#ifndef _TIME_AXIS_H
#define _TIME_AXIS_H

#include <sys/time.h>
#include <X11/Xlib.h>

void syncTime(struct timeval *base, unsigned long period);

long xpos(struct timeval *base, struct timeval *sample, 
	  unsigned long timestep);

void clear(Display *d, Window win, int lastX, int x, int width, int height);

void note_datum(int *above, int *below, int *count, 
		double min, double max, double val);


int rescale(int *above, int *below, int *count, double *min, double *max);

#endif
